﻿<?php
//Login-Daten My Renault
$username = 'DeinUsername';
$password = 'DeinPasswort';
//VIN des Renault Zoe
$vin = 'DeineVIN';
//API Schlüssel (dürfen nicht geändert werden)
$gigya_api = '3_7PLksOyBRkHv126x5WhHb-5pqC1qFR8pQjxSeLB6nhAnPERTUlwnYoznHSxwX668';
$kamereon_api = 'oF09WnKqvBDcrQzcW1rJNpjIuy7KdGaB';

//HTML Ausgabe
session_cache_limiter('nocache');
header('Content-Type: text/html; charset=utf-8');
echo "<HTML>\n<HEAD>\n<LINK REL=\"stylesheet\" HREF=\"stylesheet.css\">\n<META NAME=\"viewport\" CONTENT=\"width=device-width, initial-scale=1.0\">\n<TITLE>Renault Zoe</TITLE>\n</HEAD>\n<BODY>\n<DIV ID=\"container\">\n<MAIN>\n<ARTICLE>";

//Login Gigya
$postData = array(
    'ApiKey' => $gigya_api,
    'loginId' => $username,
    'password' => $password,
	'include' => 'data'
);
$ch = curl_init('https://accounts.eu1.gigya.com/accounts.login');
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, true);
$personId = $responseData['data']['personId'];

//Abfrage Gigya JWT Token
$postData = array(
    'oauth_token' => $responseData['sessionInfo']['cookieValue'],
    'fields' => 'data.personId,data.gigyaDataCenter'
);
$ch = curl_init('https://accounts.eu1.gigya.com/accounts.getJWT');
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, true);
$id_token = $responseData['id_token'];

//Abfrage Kamereon Account ID
$postData = array(
	'apikey: '.$kamereon_api,
	'x-gigya-id_token: '.$id_token
);
$ch = curl_init('https://api-wired-prod-1-euw1.wrd-aws.com/commerce/v1/persons/'.$personId.'?country=SE');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, TRUE);
$accountId = $responseData['accounts'][0]['accountId'];

//Abfrage Kamereon Token
$postData = array(
	'apikey: '.$kamereon_api,
	'x-gigya-id_token: '.$id_token
);
$ch = curl_init('https://api-wired-prod-1-euw1.wrd-aws.com/commerce/v1/accounts/'.$accountId.'/kamereon/token?country=SE');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, TRUE);
$accessToken = $responseData['accessToken'];

//Abfrage Akku-und Ladestatus
$postData = array(
	'apikey: '.$kamereon_api,
	'x-gigya-id_token: '.$id_token,
	'x-kamereon-authorization: Bearer '.$accessToken
);
$ch = curl_init('https://api-wired-prod-1-euw1.wrd-aws.com/commerce/v1/accounts/kmr/remote-services/car-adapter/v1/cars/'.$vin.'/battery-status');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, TRUE);
$dateTime = DateTime::createFromFormat(DateTime::ISO8601,$responseData['data']['attributes']['lastUpdateTime'],new DateTimeZone('UTC'));
$dateTime = $dateTime->setTimezone(new DateTimeZone('Europe/Berlin'));
$dateTime = $dateTime->format('d.m.Y H:i');
$chargeStatus = $responseData['data']['attributes']['chargeStatus'];
$plugStatus = $responseData['data']['attributes']['plugStatus'];
$batteryLevel = $responseData['data']['attributes']['batteryLevel'];
$batteryTemperature = $responseData['data']['attributes']['batteryTemperature'];
$rangeKm = $responseData['data']['attributes']['rangeHvacOff'];
$timeRequiredToFull = $responseData['data']['attributes']['timeRequiredToFullSlow'];
if($timeRequiredToFull != ''){
	$timeReady = DateTime::createFromFormat(DateTime::ISO8601,$responseData['data']['attributes']['lastUpdateTime'],new DateTimeZone('UTC'));
	$timeReady = $timeReady->add(new DateInterval('PT'.$timeRequiredToFull.'M'));
	$timeReady = $timeReady->setTimezone(new DateTimeZone('Europe/Berlin'));
	$timeReady = $timeReady->format('H:i');
} else {
	$timeReady = 'Zeitnah';
}
$chargePower = $responseData['data']['attributes']['chargePower'];
$instantaneousPower = $responseData['data']['attributes']['instantaneousPower']/1000;

//Abfrage Klimadaten
$postData = array(
	'apikey: '.$kamereon_api,
	'x-gigya-id_token: '.$id_token,
	'x-kamereon-authorization: Bearer '.$accessToken
);
$ch = curl_init('https://api-wired-prod-1-euw1.wrd-aws.com/commerce/v1/accounts/kmr/remote-services/car-adapter/v1/cars/'.$vin.'/hvac-status');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, TRUE);
$externalTemperature = $responseData['data']['attributes']['externalTemperature'];

//Abfrage Kilometerstand
$postData = array(
	'apikey: '.$kamereon_api,
	'x-gigya-id_token: '.$id_token,
	'x-kamereon-authorization: Bearer '.$accessToken
);
$ch = curl_init('https://api-wired-prod-1-euw1.wrd-aws.com/commerce/v1/accounts/kmr/remote-services/car-adapter/v1/cars/'.$vin.'/cockpit');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, $postData);
$response = curl_exec($ch);
if($response === FALSE){
    die(curl_error($ch));
}
$responseData = json_decode($response, TRUE);
$totalMileage = $responseData['data']['attributes']['totalMileage'];

//Ausgabe
echo "<TABLE>\n<TR ALIGN=\"left\"><TH>Renault Zoe</TH></TR>\n";
echo "<TR><TD>Kilometerstand:</TD><TD>".$totalMileage." km</TD></TR>\n";
echo "<TR><TD>Angeschlossen:</TD><TD>";
if($plugStatus === 0){
	echo "Nein";
} else {
	echo "Ja";
}
echo "</TD></TR>\n<TR><TD>Wird geladen:</TD><TD>";
if($chargeStatus === -1){
	echo "Nein";
} else {
	echo "Ja</TD></TR>\n<TR><TD>Ladetyp:</TD><TD>";
	if($chargePower === 1){
		echo "Langsam";
	} else {
		echo "Schnell";
	}
	echo "</TD></TR>\n<TR><TD>Fertig:</TD><TD>".$timeReady."</TD></TR>\n<TR><TD>Effekt:</TD><TD>".$instantaneousPower." kW";
}
echo "</TD></TR>\n<TR><TD>Akkustand:</TD><TD>".$batteryLevel." %</TD></TR>\n";
echo "<TR><TD>Reichweite:</TD><TD>".$rangeKm." km</TD></TR>\n";
echo "<TR><TD>Akkutemperatur:</TD><TD>".$batteryTemperature." &deg;C</TD></TR>\n";
echo "<TR><TD>Au&szlig;entemperatur:</TD><TD>".$externalTemperature." &deg;C</TD></TR>\n";
echo "<TR><TD>Statusupdate:</TD><TD>".$dateTime."</TD></TR>\n";
echo "<TR><TD><A HREF=\"charging_start.php\">Laden starten</A></TD></TR>\n";
echo "<TR><TD COLSPAN=\"2\"><A HREF=\"ac_now.php\">Vorklimatisierung starten</A></TD></TR>\n</TABLE>\n</ARTICLE>\n</MAIN>\n</DIV>\n</BODY>\n</HTML>";
?>